package java.rmi.activation;

import java.rmi.MarshalledObject;
import java.io.Serializable;

public final class ActivationDesc implements Serializable
{
    private ActivationGroupID groupID;
    private String className;
    private String location;
    private MarshalledObject<?> data;
    private boolean restart;
    private static final long serialVersionUID = 7455834104417690957L;
    
    public ActivationDesc(String s, String s2, MarshalledObject<?> marshalledObject) throws ActivationException {
        this(ActivationGroup.internalCurrentGroupID(), s, s2, marshalledObject, false);
    }
    
    public ActivationDesc(String s, String s2, MarshalledObject<?> marshalledObject, boolean b) throws ActivationException {
        this(ActivationGroup.internalCurrentGroupID(), s, s2, marshalledObject, b);
    }
    
    public ActivationDesc(ActivationGroupID activationGroupID, String s, String s2, MarshalledObject<?> marshalledObject) {
        this(activationGroupID, s, s2, marshalledObject, false);
    }
    
    public ActivationDesc(ActivationGroupID groupID, String className, String location, MarshalledObject<?> data, boolean restart) {
        if (groupID == null) {
            throw new IllegalArgumentException("groupID can't be null");
        }
        this.groupID = groupID;
        this.className = className;
        this.location = location;
        this.data = data;
        this.restart = restart;
        return;
    }
    
    public ActivationGroupID getGroupID() {
        return this.groupID;
    }
    
    public String getClassName() {
        return this.className;
    }
    
    public String getLocation() {
        return this.location;
    }
    
    public MarshalledObject<?> getData() {
        return this.data;
    }
    
    public boolean getRestartMode() {
        return this.restart;
    }
    
    @Override
    public boolean equals(Object o) {
        if ((o instanceof ActivationDesc)) {
            ActivationDesc activationDesc = (ActivationDesc)o;
            return ((this.groupID != null) ? this.groupID.equals(activationDesc.groupID) : (activationDesc.groupID == null)) && ((this.className != null) ? this.className.equals(activationDesc.className) : (activationDesc.className == null)) && ((this.location != null) ? this.location.equals(activationDesc.location) : (activationDesc.location == null)) && ((this.data != null) ? this.data.equals(activationDesc.data) : (activationDesc.data == null)) && this.restart == activationDesc.restart;
        }
        return false;
    }
    
    @Override
    public int hashCode() {
        return ((this.location == null) ? 0 : (this.location.hashCode() << 24)) ^ ((this.groupID == null) ? 0 : (this.groupID.hashCode() << 16)) ^ ((this.className == null) ? 0 : (this.className.hashCode() << 9)) ^ ((this.data == null) ? 0 : (this.data.hashCode() << 1)) ^ (this.restart ? 1 : 0);
    }
}
